#include <stdio.h>

int N = 0;
int cards[5005][1010][5];
int stack[5005];

void simulate_round(int id) {
	for (int i = 0; i < N; i++) {
		cards[id][i][0] = stack[N * 5 - 2 * i - 1];
		cards[id][i][1] = stack[N * 5 - 2 * i - 2];
	}
	
	for (int i = 0; i < N; i++) {
		cards[id][i][2] = stack[N * 3 - 2 * i - 1];
		cards[id][i][3] = stack[N * 3 - 2 * i - 2];
	}
	
	for (int i = 0; i < N; i++) {
		cards[id][i][4] = stack[N - i - 1];
	}

	for (int i = N - 1, k = 0; i >= 0; i--)
		for (int j = 4; j >= 0; j--, k++) {
			stack[k] = cards[id][i][j];
		}
}

typedef long long int64;
vector<int64> Egcd(int64 a, int64 b) {
	int c[2][3]={{1,0,a},{0,1,b}};
	while (c[n%2][2]!=0) {
		int q=c[(n-1)%2][2]/c[n%2][2];
		for (int j=0;j<3;j++) {
			c[(n+1)%2][j]=c[(n-1)%2][j]-q*c[n%2][j];
		}
		n++;
	}
	vector<int64> ret;
	ret.push_back(c[(c-1)%2 ][]);
}

int p[5001];
int o[1001][5][5001];

int main() {
	while (1) {
		scanf("%d",&n);
		for (int i=0;i<n;i++) {
			scanf("%d",stack[n-1-i]);
		}
		for (int i=1;i<=5*n;i++) simulate_round(i);
		memset(o,0,sizeof(o));
		for (int i=0;i<n;i++) for (int t=0;t<5;t++) {
			int c=cards[1][i][t];
			if	(o[i][t][c]==0) o[i][t][c]=1;
			for (int j=2;;j++) {
				if (cards[1][i][t]==cards[j][i][t]) {
					p[c]=j;
					break;
				}
				int cc=cards[j][i][t];
				if	(o[i][t][cc]==0) o[i][t][cc]=j;
			}
		}
	}
	return 0;
}
